﻿using UnityEngine;
using System.Collections;

// 銃
public class Gun : MonoBehaviour
{

	public enum FireMode
	{
		Auto,
		Burst,
		Single}

	;

	public FireMode fireMode;

	// 銃口・マズル
	public Transform[] projectileSpawn;
	public Projectile projectile;
	public float msBetweenShots = 100;
	public float muzzleVelocity = 35;
	public int burstCount;

	public Transform shell;
	public Transform shellEjection;
	MuzzleFlash muzzleflash;

	float nextShotTime;

	bool triggerReleasedSingleLastShot;
	int shotsRemainingInBurst;

	void Start ()
	{
		muzzleflash = GetComponent<MuzzleFlash> ();
		shotsRemainingInBurst = burstCount;
	}

	void Shoot ()
	{
		if (Time.time > nextShotTime) {

			if (fireMode == FireMode.Burst) {
				if (shotsRemainingInBurst == 0) {
					return;
				}
				shotsRemainingInBurst--;
			} else if (fireMode == FireMode.Single) {
				if (!triggerReleasedSingleLastShot) {
					return;
				}
			}

			for (int i = 0; i < projectileSpawn.Length; i++) {
				// Shot
				nextShotTime = Time.time + msBetweenShots / 1000;
				Projectile newProjectile = Instantiate (projectile, projectileSpawn [i].position, projectileSpawn [i].rotation) as Projectile;
				newProjectile.SetSpeed (muzzleVelocity);

			}
			// Shell
			Instantiate (shell, shellEjection.position, shellEjection.rotation);
			// muzzle flash
			muzzleflash.Activate ();
		}
	}

	public void OnTriggerHold ()
	{
		Shoot ();
		triggerReleasedSingleLastShot = false;
	}

	public void OnTriggerRelease ()
	{
		triggerReleasedSingleLastShot = true;
		shotsRemainingInBurst = burstCount;
	}

}
