﻿using UnityEngine;
using System.Collections;

[RequireComponent (typeof(PlayerController))]
[RequireComponent (typeof(GunController))]
public class Player : LivingEntity
{
	public float moveSpeed = 5;

	public Crosshairs crosshairs;

	Camera viewCamera;
	PlayerController controller;
	GunController gunController;

	protected override void Start ()
	{
		base.Start ();

		controller = GetComponent<PlayerController> ();
		gunController = GetComponent<GunController> ();
		viewCamera = Camera.main;
	}

	void Update ()
	{
		// 移動用入力
		Vector3 moveInput = new Vector3 (Input.GetAxisRaw ("Horizontal"), 0, Input.GetAxisRaw ("Vertical"));
		// TODO why normailze?
		Vector3 moveVelocity = moveInput.normalized * moveSpeed;
		controller.Move (moveVelocity);
	
		// プレイヤーの向きを変更するロジック
		// カメラからマウスポイントに向かう光線
		Ray ray = viewCamera.ScreenPointToRay (Input.mousePosition);
		Plane groundPlane = new Plane (Vector3.up, Vector3.up * gunController.GunHeight);
		//Plane groundPlane = new Plane (Vector3.up, Vector3.zero);
		float rayDistance;
		if (groundPlane.Raycast (ray, out rayDistance)) { // 平面と光線が交差したところまでの光線の距離が取得できる。
			Vector3 point = ray.GetPoint (rayDistance); // Ray光線は、直線がずっと続いているので、分かった距離の座標を取得
			Debug.DrawLine (ray.origin, point, Color.red);
			controller.LookAt (point);

			// 照準をマウスポインターに合わせる
			crosshairs.transform.position = point;
			crosshairs.DetectTargets (ray);
		}

		// 武器用入力
		// TODO: Input.GetMouseButton(0) と変えた。
		if (Input.GetButton ("Fire1")) {
			gunController.OnTriggerHold ();
		}
		if (Input.GetButtonUp ("Fire1")) {
			gunController.OnTriggerRelease ();
		}
	}
}
