﻿using UnityEngine;
using System.Collections;

[RequireComponent (typeof(Rigidbody))]
public class PlayerController : MonoBehaviour
{
	Vector3 velocity;
	Rigidbody myRigidBody;

	void Start ()
	{
		myRigidBody = GetComponent<Rigidbody> ();
	}

	public void Move (Vector3 _velocity)
	{
		velocity = _velocity;
	}

	public void LookAt (Vector3 lookPoint)
	{
		// 光線と地面が交差したポイントを見てしまうので、プレイヤーの高さに補正する。
		Vector3 heightCorrectedPoint = new Vector3 (lookPoint.x, transform.position.y, lookPoint.z);
		transform.LookAt (heightCorrectedPoint);
	}


	void FixedUpdate ()
	{
		myRigidBody.MovePosition (myRigidBody.position + velocity * Time.fixedDeltaTime);
	}
}
